Skip to main content Skip to footer

Building a Smart Data Table in Vue

  • 0 Comments
Quick Start Guide
What You Will Need

Wijmo

Vue

Node.js

Controls Referenced

FlexGrid

Tutorial Concept Creating a Smart Data Table in Vue - Use Wijmo's FlexGrid control to create a feature-rich, modern data table.

vue data table

Tables are common in web products because they’re one of the easiest ways to organize complex data. If your data can be represented with rows and columns, using an HTML table is the best way to display it.

However, as you’ll quickly find out, HTML tables are primitive as they don’t allow you – without adding JavaScript code – to run operations such as sorting, filtering, paginating, or exporting your data.

As a result, many JavaScript libraries provide data tables that can be used to show complex reports, dashboards, financial data, sales results, and even interactive spreadsheets.

Today, dedicated data table controls handle the table part for you. It’s not recommended to code tables in an old-fashioned way.

If you have been involved in developing data-heavy business applications, you already have an idea of how difficult it is to build these apps in a readable and maintainable way. Building a data table component that’s flexible enough to adapt to your data and business requirements can save you a lot of time. But again, developing this component is also a time-consuming task… How about outsourcing it?

Vue.js is a library for building user interfaces. It doesn’t include a built-in data table component, but many open-source libraries provide an easy-to-use API to create a data table in your Vue apps instead of coding it yourself. Naturally, you’ll need to customize it or add functionality to accommodate your use cases.

This article will show you how to implement and use a smart data table in Vue. You’ll see how to use an open-source library and customize it for our particular requirements, and then compare this process with a commercial solution from Mescius, which doesn’t need customization for most of our requirements and offers better support and updates for the latest Vue versions. We will cover:

To follow along, you need to be familiar with JavaScript and Vue.js. You also need to have Node.js installed on your development machine because the Vue CLI relies on it.

Ready to Try it Out? Download Wijmo Today!

What Should a Smart Data Table Be Able to Do?

Some features users expect to find in a modern data table are:

  1. Load data from a variety of sources, including local files, databases, and APIs
  2. Searching, filtering, and sorting options
  3. Load and display large datasets with pagination
  4. Showing and hiding columns
  5. Inline editing and writing or exporting the edited data
  6. Support for multiple devices (responsiveness)
  7. Resizable columns to accommodate long data points inside a column
  8. Horizontal and vertical scroll support
  9. Data validations and visualizations, such as sparklines

Some frameworks have built-in implementations with a few basic features, but you must code the advanced ones yourself.

For example, since data tables are used to work with complex datasets, they typically need to support the various mechanisms to import and export data with Excel spreadsheets, databases, and even REST APIs.

Open-Source Data Table Libraries

As mentioned before, Vue provides no built-in data table component, but the community of developers around it have created and open-sourced many libraries specifically designed to bridge this gap.

If you do a quick search, you’ll find many free and open-source table controls for Vue.
Here are some data table libraries that you could use in your Vue apps:

  1. Vuetify: a v-data-table component used for displaying tabular data. Features include sorting, searching, pagination, content-editing, and row selection.
  2. Vue-data-tables: a simple, customizable, and pageable table with server-side rendering (SSR) support, based on element-ui.
  3. Enso Data table: a data table package with server-side processing, unlimited exporting, and Vue components. It enables you to build complex tables based on a JSON template quickly. This package can work independently of the Enso ecosystem.
  4. Buefy Table: a set of lightweight UI components for Vue based on Bulma, including a data table that provides basic features like sorting, search, and pagination.

Implement an Open-Source Data Table in a Vue App

Let’s implement a data table in an example Vue app as an example of how you can quickly integrate an open-source component. We’ll use Vuetify, a component framework based on Material Design for developing Vue apps, including its own data table component.

Vuetify’s data table component is flexible: it supports basic features such as sorting, filtering, editing, and pagination. However, you’ll still need to add code for customizing the component in many scenarios, especially for advanced features such as exporting and importing data.

It also is missing useful UI features that can help you work comfortably with big datasets, such as resizing columns to see the full content, row step alternation, and so on.

Let’s get started by installing the Vue CLI, the official utility for generating Vue projects.
You need to have Node.js and npm installed on your local development machine. If you don’t have these, install them by following one of the methods below:

  1. Go to the official website and download the binaries for your system
  2. Use the official package manager for your system
  3. Use a Node version manager like NVM, which will enable you to manage multiple versions of Node on your system

Now open a new terminal and run the following command:

$ npm install -g @vue/cli

Next, run the following command to generate a new Vue project:

$ vue create vuedatatabledemo

You’ll be prompted to select a preset. Select Default ([Vue 2] babel, eslint).

Many libraries are not updated to support Vue 3, so we will use Vue 2 for this part of the article.

Navigate to your project’s folder and start a development server as follows:

$ cd vuedatatabledemo  
$ npm run serve

Open your web browser and navigate to http://localhost:8080/ to see your Vue app running.

Default Vue App

Now we need a REST API backend for getting data. Building an actual REST API is beyond the scope of this tutorial, so we’ll use json-server to mock a REST API from JSON data quickly.

Open a new terminal and run the following command:

$ npm install -g json-server

Next, inside your Vue project, create the db.json file and copy the product data from this db.json file, or save it directly to your project’s folder.

Run your server using the following command:

$ json-server --watch db.json --port 8000

You’ll have a http://localhost:8000/products endpoint that exposes the product data from the JSON file.

Let’s see how to consume this REST API from our Vue app and display the products in a data table. Install Vueltify, Axios, and Vue Axios.

Install Vuetify in your project using the following command:

$ vue add vuetify

You’ll be prompted to pick a preset – go with the default one.

Next, install Axios and Vue Axios using the following command:

$ npm install axios vue-axios

Open the src/main.js file and add the following code to import Axios:

import axios from 'axios'  
import VueAxios from 'vue-axios'

Vue.use(VueAxios, axios)

Define Data Tableopen the src/App.vue file and update it as follows:

<script>  
import axios from "axios";

export default {  
  name: 'App',  
  components: {  
  },  
  data: () => ({  
      products: [],  
      loading: true,  
      headers: [  
        { text: "Product Name", value: "name" },  
        { text: "Type", value: "type" },  
        { text: "SKU", value: "sku" },  
        { text: "Manufacturer", value: "manufacturer" },  
        { text: "Model", value: "model" },  
        { text: "UPC", value: "upc" },  
        { text: "Price", value: "price" }         
      ]     
  }),  
  methods: {  
    fetchData() {  
      this.loading = true;  
      axios.get("http://localhost:8000/products").then((response) => {  
          this.loading = false;  
          //console.log(response);  
          this.products = response.data;  
        });  
    },  

  },  
  mounted() {  
    this.fetchData();  
  }  
};  
</script>

In this code snippet, we start by importing Axios.

Next, in the data section, we define the loading, products array, and headers array that hold the loading state, the fetched products, and the headers of the data table, respectively.

We then define the fetchData method that calls the get method of Axios to send a GET request for fetching products.

Finally, in the mounted life-cycle method of our Vue component, we call the fetchData method to actually fetch the products and add them to the products array.

Next, let’s create the data table in the template by adding the following code to the same src/App.vue file:

<template>  
  <v-card class="p-64">  
    <v-data-table ref="myTable"  
      :headers="headers"  
      :items="products"  
      :items-per-page="10"  
      class="elevation-1">  
    </v-data-table>  
  </v-card>  
</template>

We use a v-card to create the Material card and, inside it, we use v-data-table to create the data table.

Implementing Resizable Columns

By default, the open-source data table does not have easily resized columns. Let’s see how we can enable column resizing in our data table. In StackOverflow, a user is asking how to resize columns of the Vuetify datatable, but there is no plan to implement this feature by the team behind Vuetify, so we are out of luck. We’ll have to implement this feature ourselves.

Open the src/App.vue file, add a resizableColumns method to the methods section of the component, and call it from the mounted method as follows:

// [...]  
export default {  
  name: 'App',

  components: {  
  },  
  data: () => ({  
   // [...]     
  }),  
    methods: {  
    // [...]  
    resizableColumns() {}  
    // [...]  
    },  
    mounted() {  
    // [...]  
    this.resizableColumns();  
    }  
  }

Next, let’s implement the method. Start by getting a reference to the table element in the page and define the variables as follows:

resizableColumns() {     
    let table = document.querySelector('table');  
    var initialPageX;  
    var currentColumn;  
    var nextColumn;  
    var currentColumnWidth;  
    var nextColumnWidth;

The currentColumn variable refers to the column we are currently resizing, and the nextColumn variable holds its next sibling. The initialPageX variable contains the horizontal coordinate at which the mouse is clicked.

Next, we need to query for all the table headers, iterate through them, then create and append a div element to each div element of the table with the same height at the right side. This div element is used as a bar that will be dragged to resize the column.

   if (table){  
        const columnHeaders = document.querySelectorAll('th');

        for (var i = 0; i < columnHeaders.length; i++){  
             var bar = createBar(columnHeaders[i].offsetHeight + 'px');  
             columnHeaders[i].appendChild(bar);  
             columnHeaders[i].style.position = 'relative';  
        }  
    }

Next, define the createBar method as follows:

function createBar(height) {  
  var div = document.createElement('div');  
  div.style.top = 0;  
  div.style.right = 0;  
  div.style.width = '9px';  
  div.style.borderRight = '5px solid grey';  
  div.style.position = 'absolute';  
  div.style.cursor = 'col-resize';  
  div.style.userSelect = 'none';  
  div.style.height = height;  
  div.style.zIndex = 1;

  div.addEventListener('mousedown', function (e) {  
    currentColumn = e.target.parentElement;  
    nextColumn = currentColumn.nextElementSibling;  
    initialPageX = e.pageX;

    currentColumnWidth = currentColumn.offsetWidth;  
    if (nextColumn)  
      nextColumnWidth = nextColumn.offsetWidth;  
  });

  document.addEventListener('mouseup', function () {  
    currentColumn = undefined;  
    nextColumn = undefined;  
    initialPageX = undefined;  
    nextColumnWidth = undefined;  
    currentColumnWidth = undefined  
  });

  document.addEventListener('mousemove', function (event) {  
    if (currentColumn) {  
      var resizeAmount = event.pageX - initialPageX;  
      currentColumn.style.width = (currentColumnWidth + resizeAmount) + 'px';

      if (nextColumn)  
        nextColumn.style.width = (nextColumnWidth - resizeAmount) + 'px';

    }  
  });  
  return div;  
}  

We create a div with the passed height and set some event listeners.

When the mouse is clicked, we set the current and the next column and their widths. When the mouse button is up, we reset those variables to undefined. When the mouse is moving, we calculate the amount by which we need to resize the column by subtracting the current horizontal position of the mouse from the initial position. We then add the computed amount to the width of the current column and subtract it from the width of its neighbor.

This is not yet perfect, but this shows how we can add resizing to our data table. Here is a demo of the implemented feature:

vue data table

There Must be a Better Way

That was a lot of work to get a data table into a Vue app and implement a feature common to spreadsheet apps — simply resizing a column — that the open-source development team doesn't seem to want to support.

You’d need to implement any other feature that’s missing in your data table yourself, and you may need far more code than what we have added to implement just the column resizing. This would add to your plate time-consuming tasks, which might delay the delivery of your project. You can avoid this completely by using ready data table solutions.

Mescius provides several data tables you can add to your Vue app with a few lines of code. These data tables already include column resizing and many other features that you may need to cover your use cases.

Mescius offers three components for handling data:

  1. Wijmo FlexGrid
  2. SpreadJS
  3. DataViewJS

All three are lightweight, and they are a perfect fit if you need advanced features such as drag-and-drop for rows, several selection modes, sorting, column reordering, grouping, filtering, editing, custom cells, XAML-style star-sizing columns, and so on. They can handle as much data as you want to throw at them as they are optimized for performance while handling large datasets.

The FlexGrid control provides a powerful and flexible way to display and edit data in a tabular format. It’s a full-featured grid that offers all the features you are used to, including several selection modes, sorting, column reordering, grouping, filtering, editing, custom cells, and so on. To see how to build a Vue datagrid in a minute using Wijmo's FlexGrid control, check out the video below:

SpreadJS is a JavaScript spreadsheet that allows you to provide a true Excel-like experience from your JavaScript application with zero dependencies on Excel.

This enables you to create custom spreadsheets, advanced grids, dashboards, and reports with a powerful, high-speed calculation engine, with the ability to import from and export to Excel files.

More than that, it has full support for the three popular JavaScript frameworks — React, Vue, and Angular — and also for TypeScript.

A Flexible Vue 3 Data Table with Wijmo FlexGrid

Let’s see how we can integrate FlexGrid into our Vue application.

Head back to your terminal and run the following command to install the Wijmo components for Vue:

$ npm install @mescius/wijmo.vue2.all jszip

Next, open the src/App.vue file and add the following line to import the CSS styles:

<style>  
@import '../node_modules/@mescius/wijmo.styles/wijmo.css';  
</style>

Add the following code to create a data table with FlexGrid:

import  { FlexGrid } from '@mescius/wijmo.grid';

export default {  
  name: 'App',

  components: {  
  },  
  data: () => ({  
      products: [],  
      loading: true,  
      theGrid: null,  
      /* [...] */  
}),

    methods: {  
    fetchData() {  
      this.loading = true;  
      axios.get("http://localhost:8000/products").then((response) => {  
          this.loading = false;  
          //console.log(response);  
          this.products = response.data;  
           this.createWijmoTable();  
        });  
    },  
    createWijmoTable(){  
      this.theGrid = new FlexGrid('#theGrid', {  
        stickyHeaders: true,  
        autoGenerateColumns: true,  
        alternatingRowStep: true,  
        itemsSource: this.products  
        });  
    },  
    // [...]

In the above code snippet, we first import the FlexGrid grid, then define the Grid variable in the data section of the component.

Next, we add the createWijmoTable method, in which we create our data table. Finally, we call this method in the callback of the Axios.get method to create the table when the data is fetched.

We use the itemsSource property to import data into the grid, and other properties to enable or disable specific features.

In the same file, update the code inside the template section as follows:

<template>  
  <v-card class="p-64">  
<!-- [...] -->  
      <div id="theGrid"></div>  
  </v-card>  
</template>

As you can see, without adding any custom code, we can now resize columns by default:

Resizing Table in JavaScript Vue

FlexGrid provides other features out-of-the-box, such as sticky headers, auto column generation, row step alternation, and so on.

Export to Excel with FlexGrid

Let’s add the code to enable exporting the data table to Excel. Go back to the src/App.vue file and start by importing the library for adding Excel support as follows:

import * as wjGridXlsx from '@mescius/wijmo.grid.xlsx';

Next, define the following method:

exportExcelFlexgrid() {
      var book = wjGridXlsx.FlexGridXlsxConverter.save(this.theGrid, {
        includeColumnHeaders: true,
        includeRowHeaders: true,
      });
      book.sheets[0].name = 'FlexGrid Data';
      book.saveAsync('FlexGrid-Export.xlsx');
    },

Finally, add a button to the template:

<v-btn @click="exportExcelFlexgrid">Export as Excel</v-btn>

Now, we can edit our data and then export the data table to an Excel file using the Export as Excel button.

See the sample code working in StackBlitz.

Wrapping Up

There are many ways to create and use smart data tables in Vue, with some approaches requiring a lot more manual work than others. The community has provided many free and open-source table libraries that meet many of the typical basic requirements.

However, in business and enterprise projects, where time is money, a commercial library like Wijmo can easily pay for itself many times over.

Additionally, whenever a new version of Vue is released, most open-source data table libraries are not updated to support the newest version – but with Wijmo, you don’t have to worry about the version ever being incompatible.

Ready to Try it Out? Download Wijmo Today!


Tags:

Skip to main content Skip to footer

Building a Smart Data Table in React

  • 0 Comments
Quick Start Guide
What You Will Need

Wijmo

React

Controls Referenced

FlexGrid

Tutorial Concept Creating a Smart Data Table in React Apps - Use Wijmo's popular FlexGrid control to build a feature-rich data table in React.

Tables are one of the easiest ways to present data on web pages. Plain HTML tables can meet the basic data presentation needs, but trying to squeeze anything sophisticated from them will quickly make you frustrated.

This is when you need to make some important decisions about your application development path. You can start coding enhancements around old-fashioned HTML tables — at the risk of losing focus on your project — or you look at the existing products that are designed to solve your problems.

Today’s market offers dedicated smart table controls that handle the table part for you and provide additional features, including selection modes, sorting, and column reordering.

Many companies use React data tables to show complex reports, dashboards, financial data, sales results, and even interactive spreadsheets. High demand begot specialized supply, so tables are well represented in web component libraries.

In this article, we'll discuss which capabilities are expected from a smart table, assess a few open-source alternatives, and demonstrate how to create superior HTML smart data tables with our solution for the React JavaScript library. We will explore the following sections:

You can find the finished code sample running here on StackBlitz.

Ready to Get Started? Download Wijmo Today!

Table Capabilities

There are some key features that people expect from a smart React data table.

  • Data features:

    • Load data from various sources, including local files, databases, and APIs
    • Searching, filtering, and sorting options
    • Load and display of large datasets with pagination
    • Ability to import and export data
  • UI features:

    • Showing and hiding columns
    • Inline editing
    • Responsiveness — built-in support for multiple devices
    • Resizable columns to accommodate long data points inside a column (multi-line comments)
    • Horizontal and vertical scroll support
    • Data validations and visualizations, such as sparklines

Modern frameworks have built-in implementations of some of these features. However, you have to code more advanced features yourself.

Open-Source Frameworks

Created and maintained by Facebook, React is a massively popular open-source JavaScript library. Currently, it holds around 60% of the JavaScript framework market share. With such widespread adoption in the industry, it’s no wonder that many products have been created to serve applications built on React.

Here are some popular open-source smart data table libraries made for React:

These open-source projects have advantages and disadvantages. Depending on which feature you are looking for, some of these components are better than others.

Create a React App with React Data Grid

Let’s build a new, Node-based React application with a React Data Grid, an open-source component that looks and feels similar to what we are trying to demonstrate.

Install Node.js. Then, using a command-line console, create a new Node React app:

npx create-react-app my-app  
cd my-app  
npm start

Install the React Data Grid package. Open the package.json file and add these lines in the dependencies section:

"babel-loader": "^8.1.0",  
"react-data-grid": "5.0.1",  
"react-data-grid-addons": "5.0.4",  
"bootstrap": "^4.5.2"

append the following lines after the browserslist section:

"devDependencies": {  
  "immutable": "^4.0.0-rc.12"  
}

To install the React Data Grid package and its dependencies, run the npm install command-line instruction:

npm install

Add a new data folder under the src folder, and create a new file named data.js. The user will use the data to populate our data grid:

export const recentSales = [  
  {  
    id: 1,  
    country: "Canada",  
    soldBy: "Bill",  
    client: "Cerberus Corp.",  
    description: "Prothean artifacts",  
    value: 6250,  
    itemCount: 50  
  },  
  {  
    id: 2,  
    country: "Canada",  
    soldBy: "Bill",  
    client: "Strickland Propane",  
    description: "Propane and propane accessories",  
    value: 2265,  
    itemCount: 20  
  },  
  {  
    id: 3,  
    country: "USA",  
    soldBy: "Ted",  
    client: "Dunder Mifflin",  
    description: "Assorted paper-making supplies",  
    value: 4700,  
    itemCount: 10  
  },  
  {  
    id: 4,  
    country: "USA",  
    soldBy: "Ted",  
    client: "Utopia Planitia Shipyards",  
    description: "Dilithium, duranium, assorted shipbuilding supplies",  
    value: 21750,  
    itemCount: 250  
  },  
  {  
    id: 5,  
    country: "USA",  
    soldBy: "Ted",  
    client: "Glengarry Estates",  
    description: "Desks, phones, coffee, steak knives, and one Cadillac",  
    value: 5000,  
    itemCount: 5  
  },  
  {  
    id: 6,  
    country: "Germany",  
    soldBy: "Angela",  
    client: "Wayne Enterprises",  
    description: "Suit armor and run-flat tires",  
    value: 35000,  
    itemCount: 25  
  },  
  {  
    id: 7,  
    country: "Germany",  
    soldBy: "Angela",  
    client: "Stark Industries",  
    description: "Armor and rocket fuel",  
    value: 25000,  
    itemCount: 10  
  },  
  {  
    id: 8,  
    country: "Germany",  
    soldBy: "Angela",  
    client: "Nakatomi Trading Corp.",  
    description: "Fire extinguishers and replacement windows",  
    value: 15000,  
    itemCount: 50  
  },  
  {  
    id: 9,  
    country: "UK",  
    soldBy: "Jill",  
    client: "Spaceley Sprockets",  
    description: "Anti-gravity propulsion units",  
    value: 25250,  
    itemCount: 50  
  },  
  {  
    id: 10,  
    country: "UK",  
    soldBy: "Jill",  
    client: "General Products",  
    description: "Ion engines",  
    value: 33200,  
    itemCount: 40  
  }  
];

Add a new components folder under the src folder, and create a new file named OpenSourceTable-Demo.js:

/my-app  
  /src  
    /components  
      OpenSourceTable-Demo.js

Open the OpenSourceTable-Demo.js file and add the following code. (Here, we import the ReactDataGrid component and declare the React state variables that will be used by the data grid as column definitions and the component’s data source):

import 'bootstrap/dist/css/bootstrap.min.css';  
import React, { useState } from 'react';  
import ReactDOM from "react-dom";  
import ReactDataGrid from "react-data-grid";  
import { recentSales } from "../data/data";

export const OpenSourceTableDemo = () => {

  const [columns, setColumns] = new useState([  
    { key: "id", name: "Id" },  
    { key: "country", name: "Country" },  
    { key: "soldBy", name: "Sold by" },  
    { key: "client", name: "Client" },  
    { key: "description", name: "Description" },  
    { key: "value", name: "Value" },  
    { key: "itemCount", name: "Item Count" }  
  ]);

  const [sales, setSales] = new useState(recentSales);  
}

Modify the OpenSourceTableDemo component so that it returns the HTML with the ReactDataGrid component:

return (  
  <div className="card main-panel">  
    <div className="card-header">  
      <h1>Open Source</h1>  
    </div>  
    <div className="card-body">  
    <h5>React Data Grid Demo</h5>  
      <p>  
        Building a Smart Data Table in React with React Data Grid  
      </p>           
      <div className="container-fluid">  
        <div className="row">  
            <ReactDataGrid  
                columns={columns}  
                rowGetter={i => sales[i]}  
                rowsCount={recentSales.length}  
              />  
        </div>  
      </div>  
    </div>  
  </div>);

Edit the App.js file and replace its contents with the lines below:

import React from 'react';  
import './App.css';  
import { OpenSourceTableDemo } from './components/OpenSourceTable-Demo.js'

function App() {  
  return (  
    <OpenSourceTableDemo/>  
  );  
}

export default App;

Now run the app:

npm start

Once the app is running, you’ll see the React Data Grid displaying the sales data:

Smart Data Table React

You can also check out How to Build a React Datagrid in a Minute in the video below:

To show some of the component features, let’s start customizing our open-source data grid to support cell value updates, row sorting, and column reordering.

Implement Cell Value Update

Open the OpenSourceTable-Demo.js file and add the editable: true attribute to each of the grid column definitions:

{ key: "id", name: "Id", editable: true },  
{ key: "country", name: "Country", editable: true },  
{ key: "soldBy", name: "Sold by", editable: true },  
{ key: "client", name: "Client", editable: true },  
{ key: "description", name: "Description", editable: true },  
{ key: "value", name: "Value", editable: true },  
{ key: "itemCount", name: "Item Count", editable: true }

Add a new onGridRowsUpdated function to handle cell updates and update the underlying data source:

  const onGridRowsUpdated = ({ fromRow, toRow, updated }) => {  
    const s = sales.slice();  
    for (let i = fromRow; i <= toRow; i++) {  
      s[i] = { ...s[i], ...updated };  
    }  
    setSales(s);  
  };

Modify the ReactDataGrid component to add the enableCellSelect={true} attribute and an onGridRowsUpdated={onGridRowsUpdated} event handler:

<ReactDataGrid  
  columns={columns}  
  rowGetter={i => sales[i]}  
  rowsCount={recentSales.length}  
  enableCellSelect={true}  
  onGridRowsUpdated={onGridRowsUpdated}  
/>

These changes allow your React Data Grid to handle updates and persist them in the underlying data source:

Smart Data Table React

Implement Row Sorting

Open the OpenSourceTable-Demo.js file and add the sortable: true attribute to each column definition to enable column sortability:

{ key: "id", name: "Id", editable: true, sortable: true },  
{ key: "country", name: "Country", editable: true, sortable: true },  
{ key: "soldBy", name: "Sold by", editable: true, sortable: true },  
{ key: "client", name: "Client", editable: true, sortable: true },  
{ key: "description", name: "Description", editable: true, sortable: true },  
{ key: "value", name: "Value", editable: true, sortable: true },  
{ key: "itemCount", name: "Item Count", editable: true, sortable: true }

Implement the new sortRows function:

  const sortRows = (initialRows, sortColumn, sortDirection) => rows => {  
    const comparer = (a, b) => {  
      if (sortDirection === "ASC") {  
        return a[sortColumn] > b[sortColumn] ? 1 : -1;  
      } else if (sortDirection === "DESC") {  
        return a[sortColumn] < b[sortColumn] ? 1 : -1;  
      }  
    };  
    return sortDirection === "NONE" ? initialRows : [...rows].sort(comparer);  
  };

Modify the ReactDataGrid component to implement the onGridSort event handler and reference the function we have just created:

<ReactDataGrid  
  columns={columns}  
  rowGetter={i => sales[i]}  
  rowsCount={recentSales.length}  
  enableCellSelect={true}  
  onGridRowsUpdated={onGridRowsUpdated}  
  onGridSort={(sortColumn, sortDirection) =>  
      setSales(sortRows(sales, sortColumn, sortDirection))  
  }  
/>

Go back to the web page and notice how the columns are now sortable:

Smart Data Table React

Implement Column Reordering

Open the OpenSourceTable-Demo.js file and add this declaration after the imports section:

const {  
  DraggableHeader: { DraggableContainer }  
} = require("react-data-grid-addons");

Add the draggable: true property to each column definition to enable column repositioning:

{ key: "id", name: "Id", editable: true, sortable: true, draggable: true },  
{ key: "country", name: "Country", editable: true, sortable: true, draggable: true },  
{ key: "soldBy", name: "Sold by", editable: true, sortable: true, draggable: true },  
{ key: "client", name: "Client", editable: true, sortable: true, draggable: true },  
{ key: "description", name: "Description", editable: true, sortable: true, draggable: true },  
{ key: "value", name: "Value", editable: true, sortable: true, draggable: true },  
{ key: "itemCount", name: "Item Count", editable: true, sortable: true, draggable: true }

Add the onHeaderDrop function to handle column drag-and-drop event:

const onHeaderDrop = (source, target) => {  
  var columnsCopy = columns.slice();  
  const columnSourceIndex = columns.findIndex(  
    i => i.key === source  
  );  
  const columnTargetIndex = columns.findIndex(  
    i => i.key === target  
  );

  columnsCopy.splice(  
    columnTargetIndex,  
    0,  
    columnsCopy.splice(columnSourceIndex, 1)[0]  
  );

  setColumns(columnsCopy.splice());  
  setColumns(columnsCopy);  
};

Wrap your existing ReactDataGrid component inside a new DraggableContainer component:

  <DraggableContainer onHeaderDrop={onHeaderDrop}>  
      <ReactDataGrid  
            columns={columns}  
            rowGetter={i => sales[i]}  
            rowsCount={recentSales.length}  
            enableCellSelect={true}  
            onGridRowsUpdated={onGridRowsUpdated}  
            onGridSort={(sortColumn, sortDirection) =>  
              setSales(sortRows(sales, sortColumn, sortDirection))  
            }  
        />  
  </DraggableContainer>

Rerun the app and try moving the grid columns around:

Smart Data Table React

That looks pretty good, but it was a lot of work to implement those features. Now you're on the hook to maintain that code.

Effective Alternatives

If your company develops first-rate, enterprise-grade applications, you should look into more professional products that offer support for multiple JavaScript frameworks and cover a complete functionality range.

We provide several data table products that can be implemented in a React app with a few code lines. These products are packed with a rich set of ready-to-use features that require no customization, unlike the open-source components we’ve discussed above.

Let’s have a look at several lightweight, smart table products provided, including SpreadJS, DataViewJS, and Wijmo FlexGrid.

SpreadJS

SpreadJS is the World's #1 selling JavaScript Spreadsheet with over 450 Excel functions. Using SpreadJS, you can quickly deliver Excel-like spreadsheet experiences with zero dependencies on Excel, with full support for React, Vue, Angular, and TypeScript.

SpreadJS enables you to create financial reports and dashboards, budgeting and forecasting models, scientific, engineering, healthcare, education, science lab notebooks, and other JavaScript applications for standard spreadsheet scenarios.

For more advanced spreadsheet use cases, SpreadJS allows you to create custom spreadsheets, advanced grids, dashboards, reports, and data input forms with the comprehensive API. Powered by a high-speed calculation engine, SpreadJS enables the most complex calculations.

SpreadJS supports integration by importing and exporting features that work seamlessly with the most demanding Excel.xlsx spreadsheets.

Wijmo FlexGrid

FlexGrid is one of the Wijmo product family, which also includes JavaScript/HTML5 UI Components such as FlexChart, Input, PivotChart, FinancialChart, ReportViewer, and so on. Wijmo's JavaScript DataGrid fully supports Angular, React, Vue, and Knockout.

The lightning speed, extensibility, and independence make Wijmo FlexGrid the ultimate JavaScript smart data grid. FlexGrid’s small footprint improves performance and reduces load time by keeping your web applications compact.

You can take advantage of Excel-like features of FlexGrid, such as data aggregation, cell merging, star sizing, and cell freezing. Also, Cell Templates provide limitless templates with support for declarative markup and binding expressions.

All these products are lightweight and work with virtualization, meaning they keep running at high performance even when they are connected to massive data sources.

Implement a Smart Data Table

Let’s see how to implement a Wijmo React DataGrid smart data table in the Node app we’ve built previously.

Install the Wijmo package with npm:

npm install @mescius/wijmo.react.all

In the components folder under the src folder, create a new file named WijmoFlexGrid-Demo.js:

/my-app  
  /src  
    /components  
      WijmoFlexGrid-Demo.js

Open the WijmoFlexGrid-Demo.js file and add the following code. (Here, we import the WijmoFlexGridDemo component and declare the React state variable that will be used by the FlexGrid as the component’s data source):

import '@mescius/wijmo.styles/wijmo.css';  
import 'bootstrap/dist/css/bootstrap.css';  
import '@mescius/wijmo.react.grid';  
import React, { useState } from 'react';  
import { FlexGrid, FlexGridColumn } from '@mescius/wijmo.react.grid';  
import { recentSales } from "../data/data";

export const WijmoFlexGridDemo = () => {

  const [sales, setSales] = new useState(recentSales);

    }

Modify the WijmoFlexGridDemo component so that it returns the HTML with the FlexGrid component:

return (  
    <div className="card main-panel">  
      <div className="card-header">  
          <h1>Mescius</h1>  
      </div>  
      <div className="card-body">  
      <h5>Wijmo FlexGrid Demo</h5>  
        <p>  
          Building a Smart Data Table in React  
        </p>           
        <div className="container-fluid">  
          <div className="row">  
            <FlexGrid itemsSource={sales}>  
              <FlexGridColumn width={50} binding='id' header="ID" />  
              <FlexGridColumn width={200} binding='client' header="Client" />  
              <FlexGridColumn width={320} binding='description' header="Description" />  
              <FlexGridColumn width={100} binding='value' header="Value"/>  
              <FlexGridColumn width={100} binding='itemCount' header="Quantity" />  
              <FlexGridColumn width={100} binding='soldBy' header="Sold By" />  
              <FlexGridColumn width={100} binding='country' header="Country" />  
            </FlexGrid>  
          </div>  
        </div>

      </div>  
    </div>);

Edit the App.js file to include the reference to our new WijmoFlexGridDemo component:

import React from 'react';  
import './App.css';  
import { OpenSourceTableDemo } from './components/OpenSourceTable-Demo.js'  
import { WijmoFlexGridDemo } from './components/WijmoFlexGrid-Demo.js'

function App() {  
  return (  
    // <OpenSourceTableDemo/>  
    <WijmoFlexGridDemo/>  
  );  
}

export default App;

Run the app:

npm start

Once the app is running, you’ll see the FlexGrid displaying the sales data:

Cell editing is an out-of-the-box feature in FlexGrid. You can double-click the cells and start editing in place:

Smart Data Table React

By default, a FlexGridColumn is editable. But you can disable editing by explicitly defining the isReadOnly property in the FlexGridColumn component:

<FlexGridColumn width={50} binding='id' header="ID" isReadOnly='true' />

Also, by default, every FlexGrid column is sortable in ascending or descending order.

Smart Data Table React

You can lock column sorting by setting the allowSorting property to “false”:

<FlexGridColumn width={200} binding='client' header="Client" allowSorting={false}/>

FlexGrid comes with the ability to reposition columns out of the box freely:

Smart Data Table React

You can disable column reordering by setting the FlexGridColumn’s allowDragging property to “false”:

<FlexGridColumn width={200} binding='client' header="Client" allowDragging={false}/>

So, all the customizations we need to implement on the open-source React Data Grid control are built-in here.

Import Excel Data

Let’s see how we can import Excel data into our FlexGrid component.

Append the following HTML segment after the card-body div in the return() function:

<div className="card-body">  
  <div className="card-footer">     
      <div className="input-group">  
        <div className="custom-file">  
            <input type="file" id="importFile"/>  
        </div>  
        <div className="input-group-prepend">  
            <input type="button" value="Import"/>  
        </div>  
      </div>  
  </div>

Run the application and notice the import section at the bottom of the page:

Smart Data Table React

Tell the Import button to import the file into our FlexGrid component. Add the onClick function to the input element and pass the name of the function as “import”:

<input type="button" onClick={load} value="Import"/>

Add a new load function inside the component class. Here, we’ll first obtain the full path of the user selected file:

  var load = () => {  
    let fileInput = document.getElementById("importFile");  
    if (fileInput.files[0]) {

    }  
  }

At this point, we’ll need a reference to the FlexGrid instance. Go back to the component declaration and add an event handler that is triggered when the FlexGrid is initialized:

<FlexGrid itemsSource={sales} initialized={initializeFlexGrid}>

Add a declaration for the flexgrid variable and a new function to set it up on the FlexGrid initialization:

  const [flexGrid, setFlexGrid] = useState({});  

  var initializeFlexGrid = (flexGrid) => {  
      setFlexGrid(flexGrid);  
  }

Add an import directive to the Wijmo library that handles Excel file contents:

import * as wjcGridXlsx from "@mescius/wijmo.grid.xlsx";

Back to the load function, add a call to the loadAsync function of the Wijmo library to load the file’s contents into the FlexGrid:

  var load = () => {  
    let fileInput = document.getElementById("importFile");  
    if (fileInput.files[0]) {  
      wjcGridXlsx.FlexGridXlsxConverter.loadAsync(flexGrid, fileInput.files[0], { includeColumnHeaders: true }, function (workbook) {  
        flexGrid.autoSizeColumns();  
     });  
    }  
  }

The Wijmo.xlsx library depends on a JavaScript zip library to compress files. Let’s install this dependency by running this console command:

npm install jszip --save

Rerun the app and test the import feature.

npm start

Open Excel and create a new Demo.xlsx file with these contents:

Smart Data Table React

Back in our React app, click Choose File, select the Demo.xlsx location, and click the Import button to see the result:

Smart Data Table React

Finally, let’s see what’s needed to export data from our FlexGrid to Excel.

Replace the Import button markup with the following HTML snippet to add the new Export button:

<div className="input-group-prepend">
  <div className="btn-group">
    <input type="button" onClick={load} value="Import" />
    <input
      type="button"
      onClick={save}
      className="input-group-text"
      value="Export"
    />
  </div>
</div>;

Note that the onClick event handler is pointing to the save function. Let’s implement this function inside the component class:

  var save = () => {

  }

To export FlexGrid data to an .xlsx file, we need to call the saveAsync function of the FlexGridXlsxConverter class:

  var save = () => {  
    wjcGridXlsx.FlexGridXlsxConverter.saveAsync(flexGrid, {  
        includeColumnHeaders: true,  
        includeCellStyles: false,  
        formatItem: false  
    }, "FlexGrid.xlsx");  
  }

Run the app once again and test the Export button:

Smart Data Table React

Now you can open the .xlsx file exported by the FlexGrid component:

Smart Data Table React

The above demo barely scratches the surface of the FlexGrid component. We recommend that you explore the Wijmo family of JavaScript UI Components and Tools page for complete documentation, demos, and examples written for Angular, React, and Vue.

If you want to see the finished code sample, you can find it running here on StackBlitz.

Wrapping Up

You can create and use React-based smart data tables in various ways. Some approaches require far more manual work than others, but you can’t tell that until you have already spent enough time trying to use them.

There are plenty of free and open-source table libraries that might meet your everyday needs. We’ve seen how to implement one of them in this article.

However, when it comes to business and enterprise projects, you, as a developer, don’t want to be distracted and waste your time developing workarounds, additional features, or configuration. This is why a commercial library component suite like Wijmo ensures a solid return on investment.

Built to be framework-agnostic, the Wijmo JavaScript library includes full support for Angular, React, and Vue, with the same grid across frameworks. For your organization, this means freedom of choice and the ability to save time and development effort if you decide to migrate to another JavaScript framework.

Ready to Get Started with Wijmo? Download a 30 Day Free Trial Today!


Tags: